#include "shiftregisters.h"
#include <avr/io.h> 
#include <stdint.h>
#include "../hw-layout.h"

#ifdef SHIFTin
    uint32_t read_XL_inputs(void) {       
        // Load inputs into shift register
        LOADin;      
        // read input bits in reverse order
        uint32_t result=0;        
        for (int8_t pin=0; pin<XL_INPUTS; pin++) {
            result=((uint32_t) result<<1); 
            if (DATAin) {
                result |= ((uint32_t) 1);
            }
            // Send clock pulse to input shift registers
            SHIFTin;
        }
        return result;
    }
#endif

#ifdef SHIFTout
    uint32_t xlOutputState;
    
    void write_XL_outputs(const uint32_t value) {  
        uint32_t val=value;
        for (int8_t pin=0; pin<XL_OUTPUTS; pin++) {
            // Send bit value
            DATAout(val & 1);     
            val=(uint32_t) val>>1;
            // Send clock pulse to shift output registers
            SHIFTout;
        }
        // Load output registers
        STOREout;
        xlOutputState=value;
    }
#endif
